//+------------------------------------------------------------------+
//|                      #Momentum CCi Rsi Atr Adx.mq4               |
//|                        Copyright  2014                          |
//|                                                                  |
//+------------------------------------------------------------------+


#property copyright "Copyright  2014"
#property link "http://ForexBaron.net"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 DeepSkyBlue
//#property indicator_color3 DimGray
#property indicator_level1 0
#property indicator_level2 1
#property indicator_level3 -1

//---- input parameters
extern int cciPeriod = 6;
extern int atrPeriod = 12;
extern int momentumPeriod = 7;
extern int rsiPeriod = 7;
extern int adxPeriod = 7;
extern string subtracthint = "default: -2, -1";
extern double subtractFromSignalVal = -2.0;
extern double subtractFromIndiVal = -1.0;
extern string hl1 = "-=------------------------------------------------------=-";
extern string alerthint = "optional settings:";
extern bool Alerts = true;
extern bool PlaySounds = false;
extern string alerthint1 = "Want change sounds for signals?";
extern string alerthint2 = "(must be in MT4\sounds\ directory";
extern string alerthint3 = "and have extension .wav)";
extern string LongSignalSoundFile = "alert.wav";
extern string ShortSignalSoundFile = "alert.wav";
extern bool SignalMail = False;

// internal parameters
extern int num_bars = 950;
string signalSentAlready = "NONE";
string symbol;
int timeFrame = 0;

double redSignalLineb4 = 500.0;
double blueSignalLineb4 = 500.0;
string commentText; // for screen messages
string trendDir = "NONE";
string trendDirb4 = "NONE";
string signalCross = "NONE";
string signalCrossb4 = "NONE";
string signalCrossOldBar = "NONE";
//---
int shift=0;
bool initDone=true; //  init
int bar=0;
int prevbars=0;
int startpar=0; //  start
int cs=0;
int prevcs=0;
string commodt="nonono";
int frame=0;
int bars=0;

//---- buffers
double indiBuffer[], indiBuffer1[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
SetIndexStyle(0,DRAW_LINE,1,2);
SetIndexBuffer(0,indiBuffer);
SetIndexLabel(0,"Signal Line (Red)");
//SetIndexStyle(1,DRAW_HISTOGRAM);
SetIndexStyle(1,DRAW_LINE,1,2);
SetIndexBuffer(1,indiBuffer1);
SetIndexLabel(1,"BlueLine");
//----

return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{
//---- TODO: add your code here

//----
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{
int counted_bars=IndicatorCounted();
//----
cs = cciPeriod+atrPeriod+momentumPeriod+rsiPeriod+adxPeriod+num_bars; //checksum used to see if parameters have been changed
if ((cs==prevcs)&&(commodt==Symbol())&&(frame==(Time[4]-Time[5]))&&((Bars-prevbars)<2)) startpar=Bars-prevbars; else startpar=-1; //params haven't changed only need to calculate new bar
commodt=Symbol();
frame=Time[4]-Time[5];
prevbars = Bars;
prevcs = cs;
if (startpar==1 | startpar==0) bar=startpar; else initDone = true;

if (initDone)
{
indiBuffer[num_bars-1]=0;
indiBuffer1[num_bars-1]=0;
//SetIndexValue(num_bars-1, 0);
//SetIndexValue2(num_bars-1, 0);
bar=num_bars-2;
initDone=false;
}

symbol = Symbol();
if (timeFrame == 0) timeFrame = Period();

//SetLoopCount(0);
for (shift = bar;shift>=0;shift--)
{ // start loop

// get current period data:
double momVal = iMomentum(NULL,0,momentumPeriod,PRICE_TYPICAL,shift);
double atrVal = iATR(NULL,0,atrPeriod,shift);
double cciVal = iCCI(NULL,0,cciPeriod,PRICE_TYPICAL,shift);
double rsiVal = iRSI(NULL,0,rsiPeriod,PRICE_TYPICAL,shift);
double adxVal = iADX(NULL,0,adxPeriod,PRICE_TYPICAL,MODE_MAIN,shift);
double adxPLUSVal = iADX(NULL,0,adxPeriod,PRICE_TYPICAL,MODE_PLUSDI,shift);
double adxMINUSVal = iADX(NULL,0,adxPeriod,PRICE_TYPICAL,MODE_MINUSDI,shift);

double blueSignalLine = (momVal / (atrVal + adxVal)) - subtractFromSignalVal; // -2
indiBuffer1[shift] = blueSignalLine; // BLUE

double redSignalLine = ((atrVal + cciVal + rsiVal) / adxVal) - subtractFromIndiVal; // -1
indiBuffer[shift] = redSignalLine; // RED
// get current period data END

//---- SELL SIGNAL:
if(redSignalLine < blueSignalLine && redSignalLineb4 > blueSignalLineb4 && redSignalLineb4 != 500.0 && blueSignalLineb4 != 500.0)
{
if (signalSentAlready != "short")
{
// if (showSellSignals) ExtMapBuffer2[i] = High[i] + nShift*Point;
// if (Alerts) { Alert("SELL SIGNAL at ", symbol,": ",Close[0]," (TF ",timeFrame,")"); }
if (PlaySounds) { PlaySound(ShortSignalSoundFile); }
if (SignalMail) { SendMail(""+symbol+" SELL SIGNAL","SELL SIGNAL on "+symbol+": "+Close[0]+" (Timeframe: "+timeFrame+")"); }
signalSentAlready = "short";
//alarm = "short";
}
}

//---- BUY SIGNAL:
if(redSignalLine > blueSignalLine && redSignalLineb4 < blueSignalLineb4 && redSignalLineb4 != 500.0 && blueSignalLineb4 != 500.0)
{
if (signalSentAlready != "long")
{
// if (showBuySignals) ExtMapBuffer1[i] = Low[i] - nShift*Point;
// if (Alerts) { Alert("BUY SIGNAL at ", symbol,": ",Close[0]," (TF ",timeFrame,")"); }
if (PlaySounds) { PlaySound(LongSignalSoundFile); }
if (SignalMail) { SendMail(""+symbol+" BUY SIGNAL","BUY SIGNAL on "+symbol+": "+Close[0]+" (Timeframe: "+timeFrame+")"); }
signalSentAlready = "long";
//alarm = "short";
}
}

// count time until bar ends
double ti;
int tm,ts,tk;
tm=Time[0]+Period()*60-CurTime();
ti=tm/60.0;
ts=tm%60;
tm=(tm-tm%60)/60;
// count time until bar ends END

if (redSignalLine > blueSignalLine) trendDir = "LONG";
else if (redSignalLine < blueSignalLine) trendDir = "SHORT";
else trendDir = "FLAT";
if (trendDir == "LONG" && trendDirb4 == "SHORT") signalCross = "LONG";
else if (trendDir == "SHORT" && trendDirb4 == "LONG") signalCross = "SHORT";
else signalCross = "NONE";

if (Alerts && isNewBar(symbol,timeFrame,0) && signalCrossOldBar != signalCrossb4) Alert(symbol,": new bar trend: ",signalCrossb4,"");
// if (Alerts && signalCross != "NONE") Alert(symbol,": cross: ",signalCross,"");

commentText = StringConcatenate("\n",tm + " minutes " + ts + " seconds left to bar end","\n");
commentText = commentText + StringConcatenate("\n","indicator trend: ",trendDir,"");
commentText = commentText + StringConcatenate("\n"," last cross: ",signalCrossb4," | old bar cross: ",signalCrossOldBar,"");
Comment(commentText);

// set before data = current data:
if (signalCross != "NONE") signalCrossb4 = signalCross;
// save last crossing on old bar
if (isNewBar(symbol,timeFrame,0)) signalCrossOldBar = signalCrossb4;
trendDirb4 = trendDir;
redSignalLineb4 = redSignalLine;
blueSignalLineb4 = blueSignalLine;
// set before data = current data END

} // end loop

//----
return(0);
}
//+------------------------------------------------------------------+
// isNewBar(symbol,timeFrame,0)
bool isNewBar(string symbol,int tf,int shift)
{
bool isNewBarOpen;
if (iVolume(symbol,tf,shift)>1) isNewBarOpen = false; else isNewBarOpen = true;
return(isNewBarOpen);
}


